//---------------------------------------------------------------------------
#ifndef TMyBooleanComponentH
#define TMyBooleanComponentH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
#include "dsgnintf.hpp"		// for TPropertyEditor class declaration
//---------------------------------------------------------------------------
#include "TMyBooleanEditor.h"
//---------------------------------------------------------------------------
class TMyBoolean : public TPersistent
{
private:
	bool		fValue;
protected:
public:
						__fastcall	TMyBoolean() : TPersistent() {}
    virtual				__fastcall	~TMyBoolean() {}
__published:
	__property	bool	Value = {read=fValue,write=fValue};
};
//---------------------------------------------------------------------------
class TMyBooleanComponent : public TComponent
{
private:
protected:
	TMyBoolean*	fMyBoolean;
public:
	__fastcall TMyBooleanComponent(TComponent* Owner) : TComponent(Owner)
    	{
        fMyBoolean = new TMyBoolean();
        }
    virtual	__fastcall	~TMyBooleanComponent()
    	{
        delete fMyBoolean;
        }
__published:
	__property	TMyBoolean*	MyBoolean = {read=fMyBoolean,write=fMyBoolean,nodefault};
};
//---------------------------------------------------------------------------
class TMyBooleanPropertyEditor : public TPropertyEditor
{
private:
protected:
public:
	__fastcall	TMyBooleanPropertyEditor() : TPropertyEditor() {}

	virtual		AnsiString	__fastcall	GetValue()
    	{
        TMyBoolean* myboolean = (TMyBoolean*) GetOrdValue();
        if (myboolean->Value) return "True";
        return "False";
        }
    virtual		void		__fastcall	SetValue( AnsiString Value )
    	{
        TMyBoolean* myboolean = (TMyBoolean*) GetOrdValue();
        if (Value=="True") myboolean->Value = true;
        else myboolean->Value = false;
        }
    virtual		TPropertyAttributes	__fastcall	GetAttributes()
    	{
        return TPropertyAttributes() << paDialog << paRevertable;
        }
    virtual	void	__fastcall	Edit()
    	{
        TMyBooleanEditor* f = new TMyBooleanEditor(Application);
        f->MyBoolean = (GetValue()=="True");
		if (f->ShowModal() == ID_OK)
        	{
	        if (f->MyBoolean) SetValue("True");
	        else SetValue("False");
	        Designer->Modified();
            }
        delete f;
        }
};
//---------------------------------------------------------------------------
class TMyBooleanComponentEditor : public TDefaultEditor
{
private:
protected:
public:
	__fastcall	TMyBooleanComponentEditor( TComponent* Component, TFormDesigner* Designer )
    	: TDefaultEditor( Component, Designer ) {}

    virtual	int		__fastcall	GetVerbCount()
    	{
        return 3;
        }
    virtual	AnsiString	__fastcall	GetVerb( int Index )
    	{
        AnsiString verb = "";
        switch (Index)
        	{
            case 0:	verb = "Edit"; break;
            case 1: verb = "True"; break;
            case 2: verb = "False"; break;
            }
        return verb;
        }
    virtual	void		__fastcall	ExecuteVerb( int Index )
    	{
        switch (Index)
        	{
            case 0:
            	{
                Edit();
                }
                break;
            case 1:
            	{
                ((TMyBooleanComponent*) Component)->MyBoolean->Value = true;
                Designer->Modified();
                }
                break;
            case 2:
            	{
                ((TMyBooleanComponent*) Component)->MyBoolean->Value = false;
                Designer->Modified();
                }
                break;
            }
        }
    virtual	void		__fastcall	EditProperty( TPropertyEditor* PropertyEditor, bool& Continue, bool& FreeEditor )
    	{
        if (PropertyEditor->GetName()=="MyBoolean")
        	{
            PropertyEditor->Edit();
            Continue = false;
            }
        }
__published:
};
#endif
